function [sys,x0] = Pla2LinkAnim(t,x,u,flag,q01,q02,l1,l2);
%PNDANIM2 S-function for animating the motion of a double pendulum.

%   Ned Gulley, 6-21-93
%   Copyright (c) 1990-1998 by The MathWorks, Inc. All Rights Reserved.
%   $Revision: 5.6 $

%   Modificato da Marco Gritti il 4-6-04 per utilizzo nel corso delle
%   esercitazioni di Fondamenti di Robotica, A.A. 2003/2004

global AnimFig

if flag==2,
  if any(get(0,'Children')==AnimFig),
    if strcmp(get(AnimFig,'Name'),'2GDL Planar Robot Animation'),
      set(0,'currentfigure', AnimFig);
      hndl=get(gca,'UserData');
      b=l1; c=l2;
      xSFP=0; ySFP=0;
      xBFP=xSFP+b*cos(u(1)); yBFP=ySFP+b*sin(u(1));
      xMC=xBFP+c*cos(u(1)+u(2)); yMC=yBFP+c*sin(u(1)+u(2));
      x=[xSFP xBFP NaN xBFP xMC];
      y=[ySFP yBFP NaN yBFP yMC];
      set(hndl,'XData',x,'YData',y);
      drawnow;
    end
  end
  sys=[];

elseif flag==0,
  % Initialize the figure for use with this simulation
  animinit('2GDL Planar Robot Animation');
  [flag,AnimFig] = figflag('2GDL Planar Robot Animation');
  axis([-2*l1, 2*l1, -2*l2, 2*l2]);
  hold on;
  % Set up the geometry for the problem
  % SFP=Space Fixed Pivot
  % BFP=Body Fixed Pivot
  b=l1; c=l2;
  xSFP=0; ySFP=0;
  xBFP=xSFP+b*cos(q01); yBFP=ySFP+b*sin(q01);
  xMC=xBFP+c*cos(q01+q02); yMC=yBFP+c*sin(q01+q02);
  x=[xSFP xBFP NaN xBFP xMC];
  y=[ySFP yBFP NaN yBFP yMC];
  hndl=plot(x,y, ...
           'EraseMode','background', ...
           'LineWidth',4, ...
           'Marker','.', ...
           'MarkerSize',25);
  set(gca,'DataAspectRatio',[1 1 1]);
  set(gca,'UserData',hndl);

  sys=[0 0 0 2 0 0];
  x0=[];

end