% Elaborato di Robotica Industriale - prof G.A. Magnani
% M. Gritti e W. Spinelli
%
% Criterio per la scelta dei parametri del modello
%
% UNO STUDENTE
% m1     : maggiore tra giorno e mese di nascita
% m2     : minore tra giorno e mese di nascita
%
% DUE STUDENTI
% m1     : maggiore tra giorno di nascita del primo studente e giorno di
%          nascita del secondo studente
% m2     : minore tra mese di nascita del primo studente e mese di nascita
%          del secondo studente
%
% N.B. Per semplificare il progetto del regolatore il valore della massa del
%      link 1 deve essere superiore al valore della massa del link 2


m1 = 1;     % massa del link 1
m2 = 1;     % massa del link 2

g = 9.806;  % Accelerazione di gravit?(sul pianeta Terra)
a = 1;      % Lunghezza dei link

% Momenti di inerzia visti al link1 e al link2
Jlink1 = (m1 + 7*m2)*a^2/3; % Inerzia massima (posizione di braccio esteso)
Jlink2 = (m2*a^2)/3;

% Posizioni iniziali dei giunti
q01 = 0;
q02 = 0;

% Taratura dei regolatori PID
Kc1   = 1;
Ti1   = 1;
Td1   = 1;
alfa1 = 1;

Kc2   = 1;
Ti2   = 1;
Td2   = 1;
alfa2 = 1;

% [Kc1,Ti1,Td1,alfa1] = tar_pid(Jlink1,100,0.2);
% [Kc2,Ti2,Td2,alfa2] = tar_pid(Jlink2,100,0.2);


% Inizializzazione dei controllori PID
u01 = 0.5*m1*g*a*cos(q01) + m2*g*a*(cos(q01) + 0.5*cos(q01+q02));
u02 = 0.5*m2*g*a*cos(q01+q02);

% Pesi dell'azione proporzionale e derivativa
b1 = 1;
c1 = 1;
b2 = 1;  
c2 = 1;

% Parametri di motore e trasmissione
n1   = 1;   % Rapporto di trasmissione
Kel1 = 1;   % Coefficiente di elasticit?
Del1 = 1;   % Coefficiente di smorzamento
Kt1  = 1;   % Costante di coppia
Jm1  = 1;   % Momento d'inerzia del motore
Dm1  = 1;   % Coefficiente di attrito viscoso

n2   = 1;
Kel2 = 1;
Del2 = 1;
Kt2  = 1;
Jm2  = 1;
Dm2  = 1;

% Inizializzazioni delle posizioni dei motori
qm01 = q01*n1;
qm02 = q02*n2;